import { h, ref, onMounted, reactive, watch, toRaw, nextTick } from "vue";
import { request } from "@/utils/request";
import { Search } from "@element-plus/icons-vue";
import DetailDialog from "./detailDialog.vue";
import EditDialog from "./editDialog.vue";
import AddDialog from "./addDialog.vue";
import { useRoute } from 'vue-router'
import { formatDate } from '../../../../shared/utils'

const treeData = ref([]);
const treeProps = {
    children: "children",
    label: "name",
    key: "id",
}
const filterText = ref(''); // 树节点过滤条件
const tableData = ref([]);
const qxmc = ref(''); // 区县名称
const selectedYHZData = ref(null); // 被选中的养护站数据
const yhzid = ref(''); // 养护站id
const filterData = reactive({
    sbmc: '',
    sbdl: '',
    sblx: '',
    sbzt: '',
}); // 表格过滤条件
const pagination = reactive({
    current: 1,
    pageSize: 10,
    total: 0,
    pageSizes: [10, 20, 50],
    layout: "prev, pager, next, jumper",
    onChange: (page, pageSize) => {
        pagination.current = page;
        pagination.pageSize = pageSize;
        getyhzsbList(qxmc.value, yhzid.value, filterData);
    },
}); // 表格分页
const modelVisible = ref(false); // 弹窗显示状态
const model = reactive({
    title: '',
    content: null,
    props: {},
    onCancel: null,
    onConfirm: null,
}); // 弹窗内容
const dialogType = ref(''); // 弹窗类型
const dialogRef = ref(null); // 弹窗实例
const detailDialogRef = ref(null); // 详情信息弹窗

const INIT_FORM = {
    rid: "",
    qxmc: "",
    sbbh: "",
    sbdl: "",
    sbmc: "",
    sblx: "",
    sbxh: "",
    sbwz: "",
    jd: "",
    wd: "",
    glry: "",
    glryid: "",
    czy: "",
    czyid: "",
    gzrq: "",
    gmfy: "",
    sbzt: "完好",
    sccj: "",
    sfyjsb: "",
    sfnrsjbz: "",
    fsfw: "",
    yhzid: "",
}; // 表单初始值
const form = reactive({ ...INIT_FORM }); // 表单



// 节点过滤函数
const filterNode = (value, node) => {
    const keyword = (value || '').toLowerCase();

    const nodeData = node || {}

    if (nodeData.type === 'root') {
        return true;
    }

    // 处理区域节点匹配
    if (nodeData.type === 'area') {
        return (nodeData.rawName || '').toLowerCase().includes(keyword)
    }

    // 处理站点节点匹配
    if (nodeData.type === 'site') {
        const parentData = node.parent?.data?.type === 'area' ? node.parent.data : {}
        const parentMatch = (parentData.rawName || '').toLowerCase().includes(keyword)
        return parentMatch || (nodeData.name || '').toLowerCase().includes(keyword)
    }

    return false
}
// 获取养护站列表分组
const getTreeData = async () => {
    try {
        const res = await request({
            url: '/snow-ops-platform/yhz/listAreaGroup?dataType=EQUIPMENT',
            method: 'GET'
        })
        if (res.code === '00000') {
            treeData.value = [{
                id: -1,
                name: `全部(${res.data.totalSbsl})`,
                type: "root",
                children: res.data.areaList.map((qx, index) => (
                    {
                        id: qx.qxmc,
                        name: `${qx.qxmc}(${qx.sbsl})`,
                        type: 'area',
                        children: qx.yhzList.map(site => ({
                            id: site.id,
                            name: `${site.mc}(${site.sbsl})`,
                            type: 'site',
                            qxmc: qx.qxmc,
                            rawName: site.mc,
                            jd: site.jd,
                            wd: site.wd,
                            sbwz: qx.qxmc
                        })),
                        rawName: qx.qxmc, // 原始名称
                    })
                )
            }]
            // console.log('treeData', toRaw(treeData.value))
        } else {
            throw new Error(res.message);
        }
    } catch (error) {
        ElMessage.error(error.message);
        console.log(error);
    }
};
// 处理节点点击事件
const handleNodeClick = (data, node) => {
    if (!data || !data.type) return;
    if (data.type === 'root') {
        console.log('你点击的是全部')
        yhzid.value = ''; // 重置养护站id
        qxmc.value = ''; // 重置区县名称
        selectedYHZData.value = null;
        return;
    };
    // if (data.type === 'area' && node.expanded === false) {
    //     console.log('树节点关闭', node.expanded)
    //     yhzid.value = ''; // 重置养护站id
    //     qxmc.value = ''; // 重置区县名称
    //     selectedYHZData.value = null;
    //     return;
    // }
    if (data.type === 'area') {
        console.log('你点击的是区县', data.rawName)
        yhzid.value = ''; // 重置养护站id
        qxmc.value = data.rawName; // 保存区县名称
        selectedYHZData.value = null
        return;
    }
    if (data.type === 'site') {
        console.log('你点击的是站点', data.name)
        yhzid.value = data.id; // 保存养护站id
        qxmc.value = ''; // 重置区县名称
        selectedYHZData.value = data
        return;
    }
};

// 获取养护站设备列表
const getyhzsbList = async (qxmc, yhzid, filterData) => {
    try {
        const data = {
            qxmc: qxmc,
            yhzid: yhzid,
            sbmc: filterData?.sbmc || '',
            sbdl: filterData?.sbdl || '',
            sblx: filterData?.sblx || '',
            sbzt: filterData?.sbzt || '',
            pageNum: pagination.current,
            pageSize: pagination.pageSize,
            requestSource: 'web', // web: Web端请求，app：移动端请求
        }
        const res = await request({
            url: '/snow-ops-platform/yjsb/list',
            method: 'GET',
            params: data,
        })
        if (res.code === '00000') {
            tableData.value = res.data.records;
            pagination.total = Number(res.data.total);
        } else {
            tableData.value = [];
            pagination.total = 0;
            throw new Error(res.message);
        }
    } catch (error) {
        ElMessage.error(error.message);
        console.log(error);
    }
};

const columns = [
    {
        prop: 'sbzt',
        label: '设备状态',
    },
    {
        prop: 'sbmc',
        label: '设备名称',
    },
    {
        prop: 'sbbh',
        label: '设备编号',
    },
    {
        prop: 'sbxh',
        label: '设备型号',
    },
    {
        prop: 'sbdl',
        label: '设备大类',
    },
    {
        prop: 'sblx',
        label: '设备类型',
    },
    {
        prop: 'gzrq',
        label: '购置日期',
        width: 160,
        render: (row) => {
            const el = h('span', null, [row.gzrq ? formatDate(row.gzrq) : ''])
            return el
        }
    },
    {
        prop: 'gmfy',
        label: '购买费用（万元）',
    },
    {
        prop: 'qxmc',
        label: '所属区县',
    },
    {
        prop: 'yhzmc',
        label: '所属服务站',
    },
    {
        label: '上传时间',
        width: 160,
        render: (row) => {
            const el = h('span', null, [row.tjsj ? formatDate(row.tjsj) : ''])
            return el
        }
    },
    {
        label: "操作",
        fixed: "right",
        width: 150,
        render: (row) => () =>
            h("div", { class: "action-btns" }, [
                h(
                    ElButton,
                    {
                        type: "primary",
                        link: true,
                        onClick: async () => {
                            dialogType.value = 'detail'
                            await getDetailData(row);
                        },
                    },
                    () => "详情"
                ),
                // h(
                //     ElButton,
                //     {
                //         type: "primary",
                //         link: true,
                //         onClick: async () => {
                //             dialogType.value = 'edit'
                //             await getDetailData(row);
                //         },
                //     },
                //     () => "编辑"
                // ),
                h(
                    ElButton,
                    {
                        type: "danger",
                        link: true,
                        onClick: async () => {
                            try {
                                await ElMessageBox.confirm("确定要删除该设备吗？", "删除确认", {
                                    confirmButtonText: "确定",
                                    cancelButtonText: "取消",
                                    type: "warning",
                                });
                                const res = await request({
                                    url: `/snow-ops-platform/yjsb/delete`,
                                    method: 'POST',
                                    data: {
                                        rid: row.rid,
                                    }
                                });
                                if (res.code === '00000') {
                                    ElMessage.success('删除成功');
                                    getyhzsbList(qxmc.value, yhzid.value, filterData);
                                } else {
                                    throw new Error(res.message);
                                }
                            } catch (error) {
                                ElMessage.error(error.message);
                                console.log(error);
                            }
                        },
                    },
                    () => "删除"
                ),

            ]),
    },
]

const handleEdit = async () => {
    try {
        await dialogRef?.value?.dynamicComponentRef?.formRef.validate();
        console.log('form', toRaw(form))
        const res = await request({
            url: '/snow-ops-platform/yjsb/update',
            method: 'POST',
            data: toRaw(form),
        });
        if (res.code === '00000') {
            ElMessage.success('编辑成功');
            dialogType.value = '';
            modelVisible.value = false;
            getyhzsbList(qxmc.value, yhzid.value, filterData);
        } else {
            throw new Error(res.message);
        }
    } catch (error) {
        ElMessage.error(error.message);
        console.log('error', error)
    }
};

// 获取养护站设备详情
const getDetailData = async (row) => {
    try {
        const res = await request({
            url: `/snow-ops-platform/yjsb/getById?rid=${row.rid}`,
            method: 'GET',
        });
        if (!res || res.code !== '00000') {
            throw new Error('获取物资详情失败')
        }
        if (res.code === '00000') {
            if (dialogType.value === 'detail') {
                // 打开详情
                detailDialogRef.value.showDialog(res.data)

            }
            if (dialogType.value === 'edit') {
                model.title = `编辑设备`;
                model.content = EditDialog;
                Object.assign(form, res.data.equipment);
                model.props = {
                    detailData: res.data.equipment,
                    form: form,
                };
                model.onCancel = () => {
                    dialogType.value = '';
                    modelVisible.value = false;
                };
                model.onConfirm = async () => {

                    await handleEdit();

                };
                modelVisible.value = true;
            }

        } else {
            throw new Error(res.message);
        }
    } catch (error) {
        ElMessage.error(error.message);
        console.log(error);
    }
};

// 打开新增设备弹窗
const openAddEquipmentModel = () => {
    if (!selectedYHZData.value) {
        ElMessage.error('请先选择养护站');
        return;
    }
    model.title = `新增设备`;
    model.content = AddDialog;
    const extraData = {
        jd: selectedYHZData.value.jd,
        wd: selectedYHZData.value.wd,
        yhzid: selectedYHZData.value.id,
        qxmc: selectedYHZData.value.qxmc,
        sbwz: selectedYHZData.value.sbwz,
    }
    Object.assign(form, INIT_FORM, extraData);
    model.props = {
        yhzData: selectedYHZData,
        detailData: {},
        form: form,
    };
    model.onCancel = () => {
        dialogType.value = '';
        modelVisible.value = false;
    };
    model.onConfirm = async () => {
        try {
            console.log('form', toRaw(form))
            const res = await request({
                url: '/snow-ops-platform/yjsb/add',
                method: 'POST',
                data: {
                    equipment: toRaw(form)
                },
            });
            if (res.code === '00000') {
                ElMessage.success('新增成功');
                dialogType.value = '';
                modelVisible.value = false;
                getyhzsbList(qxmc.value, yhzid.value, filterData);
            } else {
                throw new Error(res.message);
            }
        } catch (error) {
            ElMessage.error(error.message);
            console.log('error', error)
        }
    };
    modelVisible.value = true;
}




export default () => {

    const treeRef = ref(null);
    watch(() => filterText.value, (val) => {
        treeRef.value.filter(val || '')

        // 添加自动点击逻辑

        nextTick(() => {
            setTimeout(() => {
                const visibleNodes = getFilteredVisibleNodes()
                if (visibleNodes.length === 3) {
                    handleAutoClickNode(visibleNodes[0])
                }
            }, 100) // 增加 100ms 延迟确保过滤完成
        })

    })

    // 获取过滤后的可见节点
    const getFilteredVisibleNodes = () => {
        return Object.values(treeRef.value?.store?.nodesMap || {})
            .filter(node => node.visible && !node.isHidden)
    }
    const handleAutoClickNode = (node) => {
        // 展开父节点
        if (node.parent) {
            node.parent.expanded = true
        }

        // 执行点击逻辑
        handleNodeClick(
            node.data,
            {
                data: node.data,
                expanded: false,
                isCurrent: true
            }
        )
    }

    watch(
        [() => filterData, qxmc, yhzid],
        ([newFilterData, newQxmc, newYhzid]) => {
            getyhzsbList(newQxmc, newYhzid, newFilterData)
        },
        { deep: true }
    )

    const route = useRoute()


    onMounted(async () => {
        await getTreeData();
        await getyhzsbList();
        const rowData = (decodeURIComponent(route.params.data));
        if (rowData !== 'undefined' && rowData !== 'null' && rowData !== '') {
            const JSONData = JSON.parse(rowData);
            filterText.value = JSONData.mc;
        };
    });
    return {
        treeRef,
        treeData,
        treeProps,
        filterText,
        filterNode,
        handleNodeClick,

        tableData,
        filterData,
        pagination,
        columns,
        modelVisible,
        dialogRef,
        model,
        openAddEquipmentModel,

        selectedYHZData,
        detailDialogRef
    }
}